#!/bin/env python

import requests
import json
import hashlib
import base64
import time
import hmac

AccessId ='LT43KVc3vY76c68MH59g'
AccessKey 
Company = 'accruent'

#Request Info
httpVerb ='POST'
resourcePath = '/report/reports'
data = '{"type":"Alert","name":"Verisae_Alerts","format":"CSV","description":"Previous calendar months alerts","delivery":"none","dateRange":"Last Calendar Month","groupFullPath":"verisae/prod*","level":"all","sortedBy":"count","includePreexist":"false","activeOnly":"false","summaryOnly":"true","columns":[{"name":"Device","isHidden":false},{"name":"Group","isHidden":true},{"name":"Datasource","isHidden":false},{"name":"Instance","isHidden":false},{"name":"Datapoint","isHidden":false}]}'

#Construct URL 
url = 'https://'+ Company +'.logicmonitor.com/santaba/rest' + resourcePath 

#Get current time in milliseconds
epoch = str(int(time.time() * 1000))

#Concatenate Request details
requestVars = httpVerb + epoch + data + resourcePath

print requestVars

#Construct signature
signature = base64.b64encode(hmac.new(AccessKey,msg=requestVars,digestmod=hashlib.sha256).hexdigest())

#Construct headers
auth = 'LMv1 ' + AccessId + ':' + signature + ':' + epoch
headers = {'Content-Type':'application/json','Authorization':auth}

#Make request
response = requests.post(url, data=data, headers=headers)

#Print status and body of response
print 'Response Status:',response.status_code
print 'Response Body:',response.content