#!/bin/env python

import requests
import json
import hashlib
import base64
import time
import hmac

AccessId ='LT43KVc3vY76c68MH59g'
AccessKey =
Company = 'accruent'

#Request Info
httpVerb ='POST'
resourcePath = '/report/reports'
data = '{"type":"Host inventory","name":"Verisae","format":"CSV", "groupId":"70","description":"2020SOC POP-5","delivery":"none","hostsVal":"verisae/*","hostsValType":"group","properties":["auto.server.role","system.sysinfo"],"sortedBy":"system.sysinfo"}'

#Construct URL 
url = 'https://'+ Company +'.logicmonitor.com/santaba/rest' + resourcePath 

#Get current time in milliseconds
epoch = str(int(time.time() * 1000))

#Concatenate Request details
requestVars = httpVerb + epoch + data + resourcePath

print requestVars

#Construct signature
signature = base64.b64encode(hmac.new(AccessKey,msg=requestVars,digestmod=hashlib.sha256).hexdigest())

#Construct headers
auth = 'LMv1 ' + AccessId + ':' + signature + ':' + epoch
headers = {'Content-Type':'application/json','Authorization':auth}

#Make request
response = requests.post(url, data=data, headers=headers)

#Print status and body of response
print 'Response Status:',response.status_code
print 'Response Body:',response.content