# !/usr/bin/env python3
import requests
import json

subscription_id = 
client_id = "
client_secret = "
tenant_id = 


def get_token():
    """ Gets the authorization token for accessing azure.

    Returns:
        str: Azure access token
    """
    microsoft_token_url = 'https://login.microsoftonline.com/{}/oauth2/token'.format(tenant_id)
    # make the request for authorization token
    response = requests.post(
        microsoft_token_url,
        headers={
            "Content-Type": "application/x-www-form-urlencoded"
        },
        data={
            "client_id": client_id,
            "client_secret": client_secret,
            "grant_type": "client_credentials",
            "resource": "https://management.azure.com"
        }
    )
    if response.status_code == 200:
        return(response.json()['access_token'])
    else:
        raise Exception("Bad credentials")

def check_status(token):
        """ Checks the status of endpointMonitorStatus.
            endpoint.properties.endpointMonitorStatus:
            There are 6 values for this: CheckingEndpoint, Degraded, Disabled, Inactive, Online, Stopped.
            Online can be treated as green, CheckingEndpoint as a warning, all the others are critical issues.

        Args:
            token(str): Azure authorization token

        Returns:
            int: status code
                0- all good
                1- warning
                2- critical
        """
        monitor_status = ''
        url = "https://management.azure.com/subscriptions/2e315457-0aed-4e24-b149-b65c82e9693f/resourceGroups/" \
              "acc_apim_prod_backup/providers/Microsoft.Network/trafficmanagerprofiles/" \
              "acc-apim-prod-gateway?api-version=2018-04-01"
        payload = {}
        headers = {
            'Authorization': 'Bearer {}'.format(access_token)
        }
        response = requests.request("GET", url, headers=headers, data=payload)

        monitor_json = json.loads(response.text)
        status_test = ['Degraded', 'Disabled', 'Inactive', 'Stopped']
        status_list = []
        for i in monitor_json["properties"]["endpoints"]:
            status_list.append(i["properties"]["endpointMonitorStatus"])
        crit = ""
        for i in status_list:
            if i in status_test:
                crit = 1
        if crit:
            monitor_status = 2
        elif "CheckingEndpoint" in status_list:
            monitor_status = 1
        elif "Online" in status_list:
            monitor_status = 0
        return monitor_status

if __name__ == "__main__":
    access_token = get_token()
    print(check_status(access_token))
